class func {
  $func_overlord = extlookup('func_overlord')
  include func::install, func::config, func::service
}

class func::install {
  package { 'func': ensure => latest }
}

class func::config {
  File {
    require => Class['func::install'],
  }

  if $fqdn == $func_overlord {
    file { '/etc/func/overlord.conf':
      content => template('func/overlord.conf.erb'),
    }
  }

  file {
    '/etc/func/minion.conf':
      content => template('func/minion.conf.erb');
    '/etc/init.d/funcd':
      source => 'puppet:///func/funcd.init',
      mode   => 0755;
    '/etc/logrotate.d/func_rotate':
      source => 'puppet:///func/funcd.logrotate';
  }
}

class func::service {
  service { 'funcd':
    require => Class['func::config'],
    subscribe => [
      Class['func::config'],
      Package['yum'],
    ],
    enable    => true,
    ensure    => running,
  }
}
